// IssuePickerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rss_read.h"
#include "IssuePickerDlg.h"
#include ".\issuepickerdlg.h"

// CIssuePickerDlg dialog
extern CMyWinApp theApp;

IMPLEMENT_DYNAMIC(CIssuePickerDlg, CDialog)
CIssuePickerDlg::CIssuePickerDlg(CWnd* pParent, HWND hWndBugID, LPCTSTR szUrlGetIssues)
	: CDialog(CIssuePickerDlg::IDD, pParent), m_hWndBugID(hWndBugID), m_url(szUrlGetIssues), m_sortColumn(0)
{
    m_strInput.ReleaseBuffer(::GetWindowText(hWndBugID, m_strInput.GetBuffer(1024), 1023));

    m_imgList.Create(16, 16, ILC_COLOR8|ILC_MASK, 0, 15);
    m_himgList.Create(16, 16, ILC_COLOR8|ILC_MASK, 0, 3);
#define ADD_BMP(list, IDD) \
    { CBitmap bm; \
      bm.LoadBitmap(IDD); \
      list.Add(&bm, RGB(255, 255, 255)); }   
    ADD_BMP(m_imgList, IDB_BMP_TYPES);
    ADD_BMP(m_imgList, IDB_BMP_PRIORS);
    ADD_BMP(m_imgList, IDB_BMP_STATUSES);    
    ADD_BMP(m_himgList, IDB_BMP_DIR_SORTS);
}

CIssuePickerDlg::~CIssuePickerDlg()
{
}

void CIssuePickerDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_CBString(pDX, IDC_CMB_URLS, m_url);
    DDX_Control(pDX, IDC_LV_ISSUES, m_lview);
    DDX_Control(pDX, IDC_CMB_URLS, m_combo);
    DDX_Control(pDX, IDOK, m_requery);
    DDX_Control(pDX, ID_DONE, m_done);
}

BOOL CIssuePickerDlg::OnInitDialog()
{
    CWaitCursor wc;
	CDialog::OnInitDialog();
	SetIcon(AfxGetApp()->LoadIcon(IDI_MAIN_ICON), FALSE);
	SetIcon(AfxGetApp()->LoadIcon(IDI_MAIN_ICON), TRUE);
    m_lview.SetImageList(&m_imgList, LVSIL_SMALL);
    ExchangeIniSettings(FALSE);
	OnBnClickedRequery();
    HWND tooltip = (HWND)m_lview.SendMessage(LVM_GETTOOLTIPS,0,0); 
    ::SendMessage(tooltip,
        (UINT) TTM_SETDELAYTIME,
        (WPARAM) TTDT_AUTOPOP, // 20sec - didn't work at all
        (LPARAM) MAKELONG(20000,0)
        );
	return TRUE;
}

BEGIN_MESSAGE_MAP(CIssuePickerDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedRequery)
    ON_NOTIFY(NM_CLICK, IDC_LV_ISSUES, OnNMClickLvIssues)
    ON_NOTIFY(LVN_GETINFOTIP, IDC_LV_ISSUES, OnLvnGetInfoTipLvIssues)
    ON_WM_SIZE()
    ON_WM_DESTROY()
    ON_NOTIFY(HDN_ITEMCLICK, 0, OnHdnItemclickLvIssues)
    ON_BN_CLICKED(ID_DONE, OnBnClickedDone)
END_MESSAGE_MAP()


// CIssuePickerDlg message handlers

void CIssuePickerDlg::OnBnClickedRequery()
{
    CWaitCursor wc;
    UpdateData(TRUE);
    ISAXXMLReaderPtr pReader = NULL;

    HRESULT hr = pReader.CreateInstance(__uuidof(SAXXMLReader));

    CString msg;
    MyContent * pMc = new MyContent(&m_data);
    try
    {
        if (pMc==NULL) throw new CString(_T("Cannot create SAXContentHandlerImpl"));
        if(!FAILED(hr)) 
        {
            hr = pReader->putContentHandler(pMc);
            if(!FAILED(hr)) 
            {
                CString url = m_url + _T("&os_username=guest&os_password=quest");
                hr = pReader->parseURL(m_url.AllocSysString());
                if(!FAILED(hr))
                {
                    m_lview.DeleteAllItems();
                    if(m_data.m_items.GetCount()==0)
                    {
                        msg.Format(_T("Empty XML dataset returned. Parse result code: %08x"), hr);
                        throw new CString(msg);
                    }
                    int nCount = m_combo.GetCount();
                    CString str;
                    for(int i=0;i<nCount;i++)
                    {
                        m_combo.GetLBText(i,str);
                        if(str == m_url) break;
                    }
                    if(i==nCount) m_combo.AddString(m_url);
                    //fill lview
                    LVITEM lvi;
                    //lvi.iIndent = 1;
                    for(int it=0;it<m_data.m_items.GetCount();it++)
                    {
                        CXML_dbItem *pItem = m_data.m_items[it];
                        lvi.iItem = it;
                        lvi.pszText = pItem->m_key.m_value.AllocSysString();
                        lvi.iImage = stGetImageIndex(types(int(pItem->m_type)-1));
                        lvi.lParam = (LPARAM)pItem;
                        lvi.mask = LVIF_IMAGE | /*LVIF_INDENT | */LVIF_PARAM | LVIF_TEXT;
                        lvi.iSubItem = 0;
                        lvi.iItem=m_lview.InsertItem(&lvi);
                        
                        lvi.mask = LVIF_IMAGE | LVIF_TEXT;
                        lvi.iSubItem = COL_SUMMARY;
                        lvi.iImage = stGetImageIndex(priors(int(pItem->m_priority)-1));
                        lvi.pszText = pItem->m_summary.AllocSysString();
                        m_lview.SetItem(&lvi);

                        lvi.iSubItem = COL_DUE;
                        lvi.iImage = stGetImageIndex(statuses(int(pItem->m_status)-1));
                        lvi.pszText = pItem->m_due.AllocSysString();
                        m_lview.SetItem(&lvi);

                        lvi.mask = LVIF_TEXT;
                        lvi.iSubItem = COL_REPORTER;
                        lvi.pszText = pItem->m_reporter.m_username.AllocSysString();
                        m_lview.SetItem(&lvi);

                        if(InputBoxContains(pItem->m_key.m_value)) m_lview.SetCheck(lvi.iItem, TRUE);
                    }
                    SetSortColumn(m_sortColumn);
                } else
                {
	                msg.Format(_T("Error %08X in SAXXMLReader.parseURL"), hr);
                    throw new CString(msg);
                }
                pReader->putContentHandler(NULL);
            } else 
            {
	            msg.Format(_T("Error %08X in SAXXMLReader.putContentHandler"), hr);
                throw new CString(msg);
            }
        } else 
        {
	        msg.Format(_T("Error %08X in CreateInstance of SAXXMLReader"), hr);
            throw new CString(msg);
        }
	} catch (CString *err)
	{
		AfxMessageBox(*err, MB_ICONSTOP);
        delete err;
	}
}


void CIssuePickerDlg::OnNMClickLvIssues(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
    *pResult = 0;
    if(pNMIA->iItem<0) return;
    if(m_lview.GetHotItem()==-1) return;
    CXML_dbItem *pItem = (CXML_dbItem *)m_lview.GetItemData(pNMIA->iItem);
    if(pItem)
    {
        if(pItem->m_link.GetLength())
		{
			ShellExecute(this->m_hWnd, _T("open"), 
				pItem->m_link, NULL, NULL, SW_SHOWDEFAULT);
		}
    }
}

void CIssuePickerDlg::OnLvnGetInfoTipLvIssues(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMLVGETINFOTIP pGetInfoTip = reinterpret_cast<LPNMLVGETINFOTIP>(pNMHDR);
    *pResult = 0;
    if(pGetInfoTip->iItem<0) return;
    CXML_dbItem *pItem = (CXML_dbItem *)m_lview.GetItemData(pGetInfoTip->iItem);
    if(pItem)
    {
        _snwprintf(
            pGetInfoTip->pszText,
            pGetInfoTip->cchTextMax-1,
            _T("BTS: [%s] at [%s]\n\n[%s %s %s]: %d (%s)  [%s]\nInfo: %s\nAssignee: %s\nCreated: %s\nUpdated: %s\nDue date: %s"),
            LPCTSTR(m_data.m_title), LPCTSTR(m_data.m_link),
            LPCTSTR(pItem->m_status.m_value), LPCTSTR(pItem->m_priority.m_value),LPCTSTR(pItem->m_type.m_value),
            int(pItem->m_key), LPCTSTR(pItem->m_key.m_value),LPCTSTR(pItem->m_reporter.m_user_full_name),
            LPCTSTR(pItem->m_summary),
            LPCTSTR(pItem->m_assignee.m_user_full_name),
            LPCTSTR(pItem->m_created),LPCTSTR(pItem->m_updated),LPCTSTR(pItem->m_due)
            );
    }
    *pResult = 0;
}

void CIssuePickerDlg::OnSize(UINT nType, int cx, int cy)
{
    CDialog::OnSize(nType, cx, cy);
    //TRACE(_T("DlgSize: %d %d\n"), cx,cy);
    if(m_lview.m_hWnd)
    {
        m_lview.SetWindowPos(NULL,0,0,cx-21,cy-44,SWP_NOMOVE|SWP_NOZORDER);
        m_combo.SetWindowPos(NULL,0,0,cx-104,300,SWP_NOMOVE|SWP_NOZORDER);
        m_requery.SetWindowPos(NULL,cx-89,11,0,0,SWP_NOSIZE|SWP_NOZORDER);
        m_done.SetWindowPos(NULL,cx-54,11,0,0,SWP_NOSIZE|SWP_NOZORDER);
        /*CRect rct;
        m_requery.GetWindowRect(rct);
        ScreenToClient(rct);
        afxDump << _T("! pos:") << rct << _T("\n");*/
    }
}

void CIssuePickerDlg::ExchangeIniSettings(bool bSave)
{
    enum sects_keys
    { 
        SECT_DIALOG, KEY_PLACEMENT,
        SECT_URL, KEY_URL, KEY_URLS, 
        SECT_LVIEW, KEY_EXSTYLE, KEY_SORT, KEY_CAPTION, KEY_WIDTH, KEY_ORDER,
      SECT_KEY_CNT 
    };
    static LPCTSTR szConsts[SECT_KEY_CNT] = { 
        _T("DIALOG"), _T("PLACEMENT"),
        _T("URL"), _T("URL%d"), _T("URLS"), 
        _T("LVIEW"), _T("EXSTYLE"), _T("SORT"), _T("CAPTION%d"), _T("WIDTH%d"), _T("ORDER%d"),
    };
    CString key, val;
    WINDOWPLACEMENT wpl;
    BYTE *wpl_ptr = reinterpret_cast<BYTE *>(&wpl);
    wpl.length = sizeof(WINDOWPLACEMENT);
    if(bSave)
    {
        // DIALOG
        GetWindowPlacement(&wpl);
        theApp.WriteProfileBinary(szConsts[SECT_DIALOG], szConsts[KEY_PLACEMENT], wpl_ptr, wpl.length);
        // URLs
        int nCount = m_combo.GetCount();
        theApp.WriteProfileInt(szConsts[SECT_URL], szConsts[KEY_URLS], nCount);
        for(int i=0;i<nCount;i++)
        {
            key.Format(szConsts[KEY_URL], i);
            m_combo.GetLBText(i, val);
            theApp.WriteProfileString(szConsts[SECT_URL], key, val);
        }
        // LVIEW
        theApp.WriteProfileInt(szConsts[SECT_LVIEW], szConsts[KEY_SORT], m_sortColumn);
        theApp.WriteProfileInt(szConsts[SECT_LVIEW], szConsts[KEY_EXSTYLE], m_lview.GetExtendedStyle());
        TCHAR text[1000];
        LVCOLUMN lvc;
        lvc.mask = LVCF_ORDER|LVCF_TEXT|LVCF_WIDTH;
        lvc.cchTextMax = 999;
        lvc.pszText = text;
        for(int col=0;col < COL_CNT;col++)
        {
            m_lview.GetColumn(col, &lvc);
            key.Format(szConsts[KEY_WIDTH], col);
            theApp.WriteProfileInt(szConsts[SECT_LVIEW], key, lvc.cx);
            key.Format(szConsts[KEY_ORDER], col);
            theApp.WriteProfileInt(szConsts[SECT_LVIEW], key, lvc.iOrder);
            key.Format(szConsts[KEY_CAPTION], col);
            theApp.WriteProfileString(szConsts[SECT_LVIEW], key, lvc.pszText);
        }
    } else
    {
        // DIALOG
        BYTE *ptr = NULL;
        UINT len;
        if(theApp.GetProfileBinary(szConsts[SECT_DIALOG], szConsts[KEY_PLACEMENT], &ptr, &len) && len==wpl.length)
        {
            memcpy(&wpl, ptr, len); delete ptr;
            if(wpl.length==sizeof(WINDOWPLACEMENT)) SetWindowPlacement(&wpl);
        }
        // URLs
        int nUrlCount = theApp.GetProfileInt(szConsts[SECT_URL], szConsts[KEY_URLS], 0);
        for(int url=0;url<nUrlCount;url++)
        {
            key.Format(szConsts[KEY_URL], url);
            val = theApp.GetProfileString(szConsts[SECT_URL], key, _T(""));
            if(val.GetLength()) m_combo.AddString(val);
        }
        // LVIEW
        m_lview.SetExtendedStyle(theApp.GetProfileInt(szConsts[SECT_LVIEW], szConsts[KEY_EXSTYLE],
            LVS_EX_CHECKBOXES|LVS_EX_FLATSB|LVS_EX_FULLROWSELECT|LVS_EX_SUBITEMIMAGES|
            LVS_EX_HEADERDRAGDROP|LVS_EX_INFOTIP|LVS_EX_ONECLICKACTIVATE|LVS_EX_GRIDLINES|
            LVS_EX_TRACKSELECT|LVS_EX_UNDERLINEHOT));
        // COLUMNS
        LVCOLUMN lvc;
        lvc.mask = LVCF_ORDER|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        m_lview.GetHeaderCtrl()->SetImageList(&m_imgList);
        static int def_cx[COL_CNT] = {86,300,70,160};
        static LPCTSTR def_capt[COL_CNT] = { _T("Sel BugID"), _T("Summary"), _T("From"), _T("Due") };
        HD_ITEM curItem; 
        CHeaderCtrl* pHdrCtrl=m_lview.GetHeaderCtrl(); 
        pHdrCtrl->SetImageList(&m_himgList); 
        memset(&curItem, 0, sizeof(curItem)); 
        for(int col=0;col < COL_CNT;col++)
        {
            key.Format(szConsts[KEY_WIDTH], col);
            lvc.cx = theApp.GetProfileInt(szConsts[SECT_LVIEW], key, def_cx[col]);
            key.Format(szConsts[KEY_ORDER], col);
            lvc.iOrder = theApp.GetProfileInt(szConsts[SECT_LVIEW], key, col);
            lvc.iSubItem = col;
            key.Format(szConsts[KEY_CAPTION], col);
            val = theApp.GetProfileString(szConsts[SECT_LVIEW], key, def_capt[col]);
            lvc.pszText = val.GetBuffer();
            lvc.cchTextMax = val.GetLength();
            m_lview.InsertColumn(col, &lvc);
            pHdrCtrl->GetItem(col, &curItem); 
            curItem.mask = HDI_FORMAT|HDI_IMAGE; 
            curItem.iImage = stGetImageIndex(JD_NONE);
            curItem.fmt= HDF_LEFT | HDF_IMAGE | HDF_STRING | HDF_BITMAP_ON_RIGHT; 
            pHdrCtrl->SetItem(col, &curItem); 
        }

        m_sortColumn = theApp.GetProfileInt(szConsts[SECT_LVIEW], szConsts[KEY_SORT], m_sortColumn);
    }
}

void CIssuePickerDlg::OnDestroy()
{
    ExchangeIniSettings(TRUE);
    CDialog::OnDestroy();
}

int CALLBACK CIssuePickerDlg::SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	int nRetVal;
    CIssuePickerDlg *pDlg = (CIssuePickerDlg *)lParamSort;
    CString s1 = pDlg->m_lview.GetItemText((int)lParam1, abs(pDlg->m_sortColumn)-1);
    CString s2 = pDlg->m_lview.GetItemText((int)lParam2, abs(pDlg->m_sortColumn)-1);
    nRetVal = s1.Compare(s2);
    if(pDlg->m_sortColumn<0) nRetVal = -nRetVal;
	return nRetVal;
} 

void CIssuePickerDlg::OnHdnItemclickLvIssues(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
    if (phdr->iItem < 0) return;
    int newSort;
    if (phdr->iItem+1 == abs(m_sortColumn)) newSort = -m_sortColumn;
        else newSort = phdr->iItem+1;
    SetSortColumn(newSort);
    *pResult = 0;
}

void CIssuePickerDlg::SetSortColumn(int nNewSort)
{
    LVCOLUMN lvc;
    lvc.mask = LVCF_IMAGE;
    if(abs(nNewSort)!=abs(m_sortColumn)) // set old image
    {
        if(m_sortColumn) // if need
        {
            lvc.iImage = stGetImageIndex(JD_NONE);
            m_lview.SetColumn(abs(m_sortColumn)-1, &lvc);
        }
    }
    m_sortColumn = nNewSort;
    if(nNewSort) // sort ?
    {
        ListView_SortItemsEx(m_lview.m_hWnd, SortFunc, (LPARAM)this);
        lvc.iImage = stGetImageIndex(nNewSort>0 ? JD_ASCENDING : JD_DESCENDING);
        m_lview.SetColumn(abs(nNewSort)-1, &lvc);
    }
}

void CIssuePickerDlg::OnBnClickedDone()
{
    CString sAdd;
    BOOL bAdd=FALSE;
    if(m_strInput.GetLength()) bAdd = TRUE;
    for(int nItem=0;nItem<m_lview.GetItemCount();nItem++)
    {
        CXML_dbItem *pItem = (CXML_dbItem *)m_lview.GetItemData(nItem);
        BOOL bWasInInput = InputBoxContains(pItem->m_key.m_value);
        ASSERT(pItem);
        if(m_lview.GetCheck(nItem))
        {
            if(!bWasInInput)
            {
                if(bAdd) sAdd += _T(", ");
                bAdd = TRUE;
                sAdd += pItem->m_key.m_value;
            }
        } else
        {
            if(bWasInInput)
            {
                m_strInput.Replace(pItem->m_key.m_value, _T(""));
            }
        }
    }
    while (m_strInput.Replace(_T(" ,,"), _T(","))) ;
    while (m_strInput.Replace(_T(", ,"), _T(","))) ;
    while (m_strInput.Replace(_T(",,"), _T(","))) ;
    m_strInput.Trim();
    if(m_strInput.GetLength() && m_strInput.GetAt(m_strInput.GetLength()-1)==_T(','))
        m_strInput.Delete(m_strInput.GetLength()-1);
    m_strInput += sAdd;
    if(m_strInput.Find(_T(", "))==0) m_strInput.Delete(0,2);
    ::SetWindowText(m_hWndBugID, m_strInput);
    CDialog::OnOK();
}

BOOL CIssuePickerDlg::InputBoxContains(const CString &key) const
{
    int nPos = m_strInput.Find(key);
    while(nPos!=-1)
    {
        if(nPos==0 || !_istalnum(m_strInput.GetAt(nPos-1))) // before ok
        {
            if(nPos + key.GetLength() == m_strInput.GetLength() || !_istalnum(m_strInput.GetAt(nPos + key.GetLength())))
            {
                return TRUE;
            }
        }
        nPos++;
        nPos = m_strInput.Find(key, nPos);
    }
    return FALSE;
}
