#include "stdafx.h"
#include "rss_worker.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

const wchar_t *CXML_dbRSS_Channel::st_c[CXML_dbRSS_Channel::T_CNT]=
{
	_T("rss"),_T("channel"), _T("title"), _T("link"), _T("description"), _T("language"), _T("item"), 
    _T("key"), _T("id"), _T("summary"), _T("type"), _T("priority"), 
    _T("status"), _T("resolution"), _T("assignee"), _T("username"), _T("reporter"),
    _T("created"), _T("updated"), _T("due"),
    _T("customfields"), _T("customfield"), _T("customfieldname"), _T("customfieldvalues"), _T("customfieldvalue")
};
#define TOK(i) CXML_dbRSS_Channel::st_c[CXML_dbRSS_Channel::i]

MyContent::MyContent(CXML_dbRSS_Channel *pData) : m_pChars(NULL), m_pItem(NULL), m_depth(0), m_pData(pData)
{
    ASSERT(pData);
}

MyContent::~MyContent()
{
}

HRESULT STDMETHODCALLTYPE MyContent::startElement(
            /* [in] */ wchar_t __RPC_FAR * pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR * pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR * pwchQName,
            /* [in] */ int cchQName,
            /* [in] */ ISAXAttributes __RPC_FAR *pAttributes)
{
   m_depth++;
   CString *pAttrUSERNAME = NULL;
   CXML_dbID *pAttrID = NULL;
   switch(m_depth)
   {
   case 3: // title link description language item
       if(cchLocalName==5 && wcsncmp(pwchLocalName, TOK(title), 5)==0)
       {
           m_pChars = &m_pData->m_title;
       } else if(cchLocalName==4 && wcsncmp(pwchLocalName, TOK(link), 4)==0)
       {
           m_pChars = &m_pData->m_link;
       } else if(cchLocalName==11 && wcsncmp(pwchLocalName, TOK(description), 11)==0)
       {
           m_pChars = &m_pData->m_description;
       } else if(cchLocalName==8 && wcsncmp(pwchLocalName, TOK(language), 8)==0)
       {
           m_pChars = &m_pData->m_language;
       } else if(cchLocalName==4 && wcsncmp(pwchLocalName, TOK(item), 4)==0)
       {
           m_pData->m_items.Add(m_pItem = new CXML_dbItem);
       } else return S_OK;
       break;
   case 4: // title link key[id] summary type[id] priority[id] status[id] 
           // resolution assignee[username] reporter[username] created updated due
       if(m_pItem)
       {
           if(cchLocalName==4 && wcsncmp(pwchLocalName, TOK(link), 4)==0)
            {
                m_pChars = &m_pItem->m_link;
            } else if(cchLocalName==7 && wcsncmp(pwchLocalName, TOK(summary), 7)==0)
            {
                m_pChars = &m_pItem->m_summary;
            } else if(cchLocalName==10 && wcsncmp(pwchLocalName, TOK(resolution), 10)==0)
            {
                m_pChars = &m_pItem->m_resolution;
            } else if(cchLocalName==7 && wcsncmp(pwchLocalName, TOK(created), 7)==0)
            {
                m_pChars = &m_pItem->m_created;
            } else if(cchLocalName==7 && wcsncmp(pwchLocalName, TOK(updated), 7)==0)
            {
                m_pChars = &m_pItem->m_updated;
            } else if(cchLocalName==3 && wcsncmp(pwchLocalName, TOK(due), 3)==0)
            {
                m_pChars = &m_pItem->m_due;
            } else if(cchLocalName==3 && wcsncmp(pwchLocalName, TOK(key), 3)==0)
            {
                m_pChars = &m_pItem->m_key.m_value; pAttrID = &m_pItem->m_key;
            } else if(cchLocalName==4 && wcsncmp(pwchLocalName, TOK(type), 4)==0)
            {
                m_pChars = &m_pItem->m_type.m_value; pAttrID = &m_pItem->m_type;
            } else if(cchLocalName==8 && wcsncmp(pwchLocalName, TOK(priority), 8)==0)
            {
                m_pChars = &m_pItem->m_priority.m_value; pAttrID = &m_pItem->m_priority;
            } else if(cchLocalName==6 && wcsncmp(pwchLocalName, TOK(status), 6)==0)
            {
                m_pChars = &m_pItem->m_status.m_value; pAttrID = &m_pItem->m_status;
            } else if(cchLocalName==8 && wcsncmp(pwchLocalName, TOK(assignee), 8)==0)
            {
                m_pChars = &m_pItem->m_assignee.m_user_full_name; pAttrUSERNAME = &m_pItem->m_assignee.m_username;
            } else if(cchLocalName==8 && wcsncmp(pwchLocalName, TOK(reporter), 8)==0)
            {
                m_pChars = &m_pItem->m_reporter.m_user_full_name; pAttrUSERNAME = &m_pItem->m_reporter.m_username;
            } else return S_OK;
       } else return S_OK;
       break;
   default: return S_OK;
   }
   if(m_pChars) { m_pChars->Empty(); m_pChars->GetBuffer(128); }
   LPCTSTR attr_tok=NULL; int attr_size=0;
   if (pAttrUSERNAME) { attr_tok=TOK(username); attr_size=8; }
   if (pAttrID) { attr_tok=TOK(id); attr_size=2; }
   if(attr_tok)
   {
      int l;
      pAttributes->getLength(&l);
      for ( int i=0; i<l; i++ ) 
        {
            wchar_t *ln, *vl; int lnl, vll;
            pAttributes->getLocalName(i,&ln,&lnl);
            if(lnl == attr_size && wcsncmp(ln, attr_tok, attr_size)==0)
            {
                pAttributes->getValue(i,&vl,&vll);
                static wchar_t val[100];
                vll = vll>99 ? 99 : vll;
                wcsncpy( val, vl, vll ); val[vll] = 0;
                if(pAttrUSERNAME) *pAttrUSERNAME=vl;
                if(pAttrID) *pAttrID=int(_tstoi(val));
                break;
            }            
        }
   }
   return S_OK;
}


HRESULT STDMETHODCALLTYPE MyContent::endElement(
            /* [in] */ wchar_t __RPC_FAR * pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR * pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR * pwchQName,
            /* [in] */ int cchQName)
{
    m_depth--;
    m_pChars = NULL;
    return S_OK;
}

HRESULT STDMETHODCALLTYPE MyContent::characters(
            /* [in] */ wchar_t __RPC_FAR * pwchChars,
            /* [in] */ int cchChars)
{
    if(m_pChars)
    {
        static wchar_t val[1000];
        cchChars = cchChars>999 ? 999 : cchChars;
        wcsncpy( val, pwchChars, cchChars ); val[cchChars] = 0;
        *m_pChars += val;
    }
    return S_OK;
}        

HRESULT STDMETHODCALLTYPE MyContent::startDocument()
{
    // reset automate
    m_pChars = NULL;
    m_pItem = NULL;
    m_depth=0;
    m_pData->Cleanup();
    return S_OK;
}
